> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/pt-br/web-scraper-api/alvos/e-commerce/menards.md).

# Menards

Saiba como começar a fazer scraping do Menards.

Com o Web Scraper API, você pode raspar vários tipos de **Menards** páginas; abaixo está uma visão geral de todos os scrapers suportados e seus respectivos `valores de origem` valores. A resposta retorna o HTML da página em `conteúdo`, na estrutura de resposta padrão descrita em [Realtime](/products/pt-br/web-scraper-api/integration-methods/realtime.md) e [Push-Pull](/products/pt-br/web-scraper-api/integration-methods/push-pull.md).

{% hint style="warning" %}
Para alguns alvos, nosso sistema **força a renderização de JavaScript** mesmo que você não defina `render`; essas requisições contam como tráfego renderizado. A lista de alvos com renderização forçada e como desativar a renderização está em [Forçando a renderização em páginas específicas](/products/pt-br/web-scraper-api/features/js-rendering-and-browser-control.md#forcing-rendering-on-specific-pages).
{% endhint %}

<table><thead><tr><th width="250">Origem</th><th>Descrição</th></tr></thead><tbody><tr><td><code>menards_search</code></td><td><a href="#search"><strong>Página de busca</strong></a> para um termo de busca de sua escolha.</td></tr><tr><td><code>menards_product</code></td><td><a href="#product"><strong>Página do produto</strong></a> de um ID de produto de sua escolha.</td></tr></tbody></table>

Qualquer outra página da Menards pode ser raspada passando seu `url` sozinha, sem `valores de origem` necessidade.

{% hint style="info" %}
Além dos parâmetros listados abaixo, você pode incluir parâmetros adicionais como `user_agent_type`, `geo_location`, `render`, e muito mais para personalizar sua requisição de scraping. Leia mais [aqui](/products/pt-br/web-scraper-api/features.md).
{% endhint %}

## Busca

### Exemplos de requisição

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "menards_search",
        "query": "shower"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'menards_search',
    'query': 'shower'
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "menards_search",
    query: "shower"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# The whole string you submit has to be URL-encoded.

https://realtime.oxylabs.io/v1/queries?source=menards_search&query=shower&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'menards_search',
    'query' => 'shower'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "menards_search",
        "query": "shower",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "menards_search",
                query = "shower"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "menards_search");
        jsonObject.put("query", "shower");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "menards_search",
    "query": "shower"
}
```

{% endtab %}
{% endtabs %}

### Valores dos parâmetros da requisição <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="238.48828125">Parâmetro</th><th>Descrição</th><th width="160">Valor padrão</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>valores de origem</code></strong></mark></td><td>Define o scraper.</td><td><code>menards_search</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td>A palavra-chave ou frase para pesquisar produtos.</td><td>-</td></tr><tr><td><code>start_page</code></td><td>Número da página inicial.</td><td>1</td></tr><tr><td><code>store_id</code>, <code>pickup_at_store_eligible</code>, <code>in_stock_today</code>, <code>fulfillment_center</code>, <code>delivery_eligible</code></td><td>Filtros opcionais de localização e disponibilidade, consulte <a href="#localization-and-filtering">Localização e filtragem</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- parâmetro obrigatório

## Produto <a href="#product" id="product"></a>

### Exemplos de requisição

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "menards_product",
        "product_id": "1642874368501448"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'menards_product',
    'product_id': '1642874368501448'
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "menards_product",
    product_id: "1642874368501448"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# The whole string you submit has to be URL-encoded.

https://realtime.oxylabs.io/v1/queries?source=menards_product&product_id=1642874368501448&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'menards_product',
    'product_id' => '1642874368501448'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "menards_product",
        "product_id": "1642874368501448",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "menards_product",
                product_id = "1642874368501448"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "menards_product");
        jsonObject.put("product_id", "1642874368501448");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "menards_product",
    "product_id": "1642874368501448"
}
```

{% endtab %}
{% endtabs %}

### Valores dos parâmetros da requisição <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">Parâmetro</th><th>Descrição</th><th width="160">Valor padrão</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>valores de origem</code></strong></mark></td><td>Define o scraper.</td><td><code>menards_product</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>product_id</code></strong></mark></td><td>O ID numérico do produto da URL da página do produto, os dígitos após <code>p-</code>, por exemplo, <code>menards.com/main/…/p-</code><strong><code>1642874368501448</code></strong><code>-c-19565.htm</code>.</td><td>-</td></tr><tr><td><code>store_id</code></td><td>Parâmetro de localização opcional, veja <a href="#localization-and-filtering">Localização e filtragem</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- parâmetro obrigatório

## Localização e filtragem <a href="#localization-and-filtering" id="localization-and-filtering"></a>

<table><thead><tr><th width="150">Parâmetro</th><th width="170">Aplica-se a</th><th>Descrição</th><th width="90">Padrão</th></tr></thead><tbody><tr><td><code>store_id</code></td><td><code>menards_search</code>, <code>menards_product</code></td><td>Número da loja como uma cadeia de caracteres, obtido da URL da página da loja em menards.com, por exemplo <code>"3045"</code> from <code>/store.html?store=3045</code>. Os preços e a disponibilidade são mostrados para essa loja.</td><td>-</td></tr><tr><td><code>pickup_at_store_eligible</code></td><td><code>menards_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos disponíveis para retirada na loja.</td><td>-</td></tr><tr><td><code>in_stock_today</code></td><td><code>menards_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos em estoque hoje.</td><td>-</td></tr><tr><td><code>fulfillment_center</code></td><td><code>menards_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos enviados de um centro de fulfillment da Menards.</td><td>-</td></tr><tr><td><code>delivery_eligible</code></td><td><code>menards_search</code></td><td>Defina como <code>true</code> para mostrar apenas produtos elegíveis para entrega em domicílio.</td><td>-</td></tr></tbody></table>

Os quatro filtros aceitam `true` apenas; deixe um filtro de fora para desativá-lo.

```json
{
    "source": "menards_search",
    "query": "drill",
    "store_id": "3045",
    "pickup_at_store_eligible": true
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/pt-br/web-scraper-api/alvos/e-commerce/menards.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
